//http://www.vbaccelerator.com/home/VB/Code/vbMedia/Audio/MP3_Encoding_with_LAME/article.asp

// http://lame.sourceforge.net/index.php

//#define _mp3tag
//#define _lame_nosubs
//#include "lame.inc"

//declare mp3callback(void *mp3data, int datasize);



#use "lame_enc.lib"

CONST WAVE_FORMAT_MPEGLAYER3 = 0x0055;

declare cdecl import, beInitStream 
( 
		BE_CONFIG *config, 
		DWORD *pdwSamples, /*receives the number of samples the encoder will process in each block*/
		DWORD *pdwBufferSize, /*the size of the buffer to allocate to receive output from the encoder*/
		HANDLE *phbeStream /*the handle to the newly opened stream, if successful*/
	),INT;

declare cdecl import, beEncodeChunk ( HANDLE hbeStream, int nSamples, void* pSamples, void* pOutput, DWORD* pdwOutput),INT;

declare cdecl import, beDeinitStream ( HANDLE hbeStream, void* pOutput, DWORD* pdwOutput),INT;

declare cdecl import, beCloseStream (HANDLE  hbeStream),INT;

//Enum ELameErrorCode
	const BE_ERR_SUCCESSFUL                = 0;
	const BE_ERR_INVALID_FORMAT            = 1;
	const BE_ERR_INVALID_FORMAT_PARAMETERS = 2;
	const BE_ERR_NO_MORE_HANDLES           = 3;
	const BE_ERR_INVALID_HANDLE            = 4;
	const BE_ERR_BUFFER_TOO_SMALL          = 5;

	const VBR_QUALITY_0_HIGHEST = 0;
	const VBR_QUALITY_1_HIGH    = 1;
	const VBR_QUALITY_2_HIGH    = 2;
	const VBR_QUALITY_3_MID     = 3;
	const VBR_QUALITY_4_MID     = 4;
	const VBR_QUALITY_5_MID     = 5;
	const VBR_QUALITY_6_MID     = 6;
	const VBR_QUALITY_7_LOW     = 7;
	const VBR_QUALITY_8_LOW     = 8;
	const VBR_QUALITY_9_LOWEST  = 9;

	const VBR_METHOD_NONE    = -1;
	const VBR_METHOD_DEFAULT = 0;
	const VBR_METHOD_OLD     = 1;
	const VBR_METHOD_NEW     = 2;
	const VBR_METHOD_ABR     = 4;

	const BE_MP3_MODE_STEREO      = 0;
	const BE_MP3_MODE_JSTEREO     = 1;
	const BE_MP3_MODE_DUALCHANNEL = 2;
	const BE_MP3_MODE_MONO        = 3;

	// enum LAME_QUALTIY_PRESET
	const   LQP_NOPRESET         = -1;
	// STANDARD QUALITY PRESETS
	const   LQP_NORMAL_QUALITY   = 0;
	const   LQP_LOW_QUALITY      = 1;
	const   LQP_HIGH_QUALITY     = 2;
	const   LQP_VOICE_QUALITY    = 3;
	const   LQP_R3MIX_QUALITY    = 4;
	const   LQP_VERYHIGH_QUALITY = 5;
	// NEW PRESET VALUES
	const   LQP_PHONE   =1000;
	const   LQP_SW      =2000;
	const   LQP_AM      =3000;
	const   LQP_FM      =4000;
	const   LQP_VOICE   =5000;
	const   LQP_RADIO   =6000;
	const   LQP_TAPE    =7000;
	const   LQP_HIFI    =8000;
	const   LQP_CD      =9000;
	const   LQP_STUDIO  =10000;


	struct BE_CONFIG_FORMAT_LHV1,1
	{
		DWORD dwStructVersion; /*1*/
		DWORD dwStructSize;    /*331*/
		DWORD dwSampleRate;
		//32000, 44100 or 48000 for MPEG-I
		//16000, 22050 or 24000 for MPEG-I
		// 8000, 11025 or 12000 for MPEG-II.5

		DWORD dwReSampleRate;
		INT  nMode;
		//BE_MP3_MODE_STEREO
		//BE_MP3_MODE_JSTEREO
		//BE_MP3_MODE_DUALCHANNEL
		//BE_MP3_MODE_MONO

		DWORD dwBitRate;
		DWORD dwMaxBitrate; /*8n*/
		INT  nPreset;      /*LAME_QUALTIY_PRESET*/
		//LQP_NOPRESET         - don't use any presets
		//LQP_NORMAL_QUALITY   - quality is set to 5.
		//LQP_LOW_QUALITY      - quality is set to 9.
		//LQP_HIGH_QUALITY     - quality is set to 2.
		//LQP_VOICE_QUALITY    - use for voice encoding.
		//LQP_R3MIX            - r3mix preset option
		//LQP_VERYHIGH_QUALITY - quality is set to 0
		//LQP_STANDARD         - lame command line alt-preset standard
		//LQP_FAST_STANDARD    - lame command line alt-preset fast standard
		//LQP_EXTREME          - lame command line alt-preset extreme
		//LQP_FAST_EXTREME     - lame command line alt-preset fast extreme.
		//LQP_INSANE           - lame command line alt-preset insane.
		//LQP_ABR              - lame command line alt-preset abr.
		//LQP_CBR              - lame command line alt-preset cbr

		DWORD dwMpegVersion;
		//MPEG1 = 1
		//MPEG2 = 0

		DWORD dwPsyModel; /*nc*/
		DWORD dwEmphasis; /*nc*/
		BOOL  bPrivate;
//If this is set to TRUE (1) the Private bit in the MP3 stream will be set

		BOOL  bCRC;
//Set this to TRUE in order to enable CRC-checksum in the bitstream

		BOOL  bCopyright;
//If this is set to TRUE the Copyright bit in the MP3 stream will be set
		BOOL  bOriginal;
//If this is set to TRUE the Original bit in the MP3 stream will be set

		BOOL  bWriteVBRHeader;
//Specifes if the XING VBR header should be written or not. When this option is enabled,
//you have to call the beWriteVBRHeader function when encoding has been completed.
//Keep in mind that the VBR info tag can also be written for CBR encoded files,
//the TAG info can be useful for additional info like encoder delay and the like

		BOOL  bEnableVBR;
//Whether to enable VBR encoding

		INT  nVBRQuality;
		//VBR_QUALITY_**

		BOOL dwVbrAbr_bps;
		//MPEG-I: 32000 .. 320000 bps
		//MPEG-II: 8000 .. 160000 bps

		INT  nVBRMethod;
		//VBR_METHOD_**

		BOOL  bNoBitRes;
//Disables the bit-resorvoir and disables the insertion of padded frames

		INT  bStrictIso;
//Set strict ISO compatibility for the encoding

		INT  nQuality;
//Set the quality, from 0 (highest) to 9 (lowest). For backward compatibility reasons,
//the quality value must have the high-byte set to Not the low-byte.
//So the values will be: 0xFF00 = 0, 0xFE01 = 1 ... 0xF609 = 9
		dstring bPadding[237]; /*nc*/
	}


	struct BE_CONFIG_FORMAT,1
	{
		BE_CONFIG_FORMAT_LHV1 lvh1;
	}

	struct BE_CONFIG,1
	{
		DWORD dwConfig;	/*BE_CONFIG_LAME*/
		BE_CONFIG_FORMAT format;
	}

//Enum EBeConfigFormat
const BE_CONFIG_MP3  = 0;
const BE_CONFIG_LAME = 256;

#ifndef _lame_nosubs

//	BE_CONFIG    bc
//	beSetupHeader(bc, 44100, BE_MP3_MODE_STEREO, 128, 9)
/*
sub beSetupHeader(BE_CONFIG bc,int SampleRate,int nMode,int BitRate,int quality)
{
	bc.dwConfig = BE_CONFIG_LAME;
	bc.format.lvh1.dwStructVersion = 1;
	bc.format.lvh1.dwStructSize    = 331;
	bc.format.lvh1.dwSampleRate    = SampleRate;
	bc.format.lvh1.dwReSampleRate  = SampleRate;
	bc.format.lvh1.nMode           = nMode;
	bc.format.lvh1.dwBitRate       = BitRate;
	bc.format.lvh1.nPreset         = LQP_NOPRESET;
	bc.format.lvh1.dwMpegVersion   = 1;
	bc.format.lvh1.nQuality        = (quality||0xF)<<8 | quality; // 0xF609
	return;
}
*/
// ----------------------------------------|
// mp3 class



class CLameEnc
{
	// private
	declare  CLameEnc();
	declare virtual SetupHeader();
	// public:
	declare virtual Create(string *path),BOOL;
	declare virtual AttachToFile(HANDLE hFile),BOOL;
	declare virtual Write(word *pwWaveSamples, int size);
	declare virtual Close();
	// public:
	DWORD  m_bitrate; // 128
	DWORD  m_samplerate;// 44100
	DWORD  m_mode;    // BE_MP3_MODE_STEREO
	int    m_quality; // 9
	BOOl   m_attached;

	// private:
	HANDLE m_hFile;
	DWORD  m_Samples;
	DWORD  m_memo_mp3_size;
	DWORD  m_hbeStream;
	void  *m_memo_mp3;
	BE_CONFIG m_config;
}
CLameEnc::CLameEnc()
{
	ZeroMemory(&m_hFile, &m_config - &m_bitrate);
	ZeroMemory(m_config, sizeof(BE_CONFIG));
	m_bitrate    = 128;
	m_samplerate = 44100;
	m_mode       = BE_MP3_MODE_STEREO;
	m_quality    = 9;
	m_attached   = false;
	m_config.format.lvh1.dwStructVersion = 1;
	m_config.format.lvh1.dwStructSize    = 331;
}
CLameEnc::SetupHeader()
{
	m_config.dwConfig = BE_CONFIG_LAME;
	m_config.format.lvh1.dwSampleRate    = m_samplerate;
	m_config.format.lvh1.dwReSampleRate  = m_samplerate;
	m_config.format.lvh1.nMode           = m_mode;
	m_config.format.lvh1.dwBitRate       = m_bitrate;
	m_config.format.lvh1.nPreset         = LQP_NOPRESET;
	m_config.format.lvh1.dwMpegVersion   = 1;
	m_config.format.lvh1.nQuality        = ((m_quality xor 0xF)<<8) | m_quality;
}




CLameEnc::Create(string *path),BOOL
{
	if (m_memo_mp3) delete m_memo_mp3;
	m_memo_mp3 = null;

	SetupHeader();
	if (!beInitStream(m_config, &m_Samples, &m_memo_mp3_size, &m_hbeStream))
	{
		m_hFile = CreateFile(path, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, 0, 0);
		if (m_hFile != INVALID_HANDLE_VALUE) {
			m_memo_mp3 = new(byte, m_memo_mp3_size);
		}
	}
	return (m_memo_mp3 != null);
}


CLameEnc::AttachToFile(HANDLE hFile),BOOL
{
	if (m_memo_mp3) delete m_memo_mp3;
	m_memo_mp3 = null;
	SetupHeader();

	if (!beInitStream(m_config, &m_Samples, &m_memo_mp3_size, &m_hbeStream))
	{
		m_hFile = hFile;
		m_attached = true;
		if (m_hFile != INVALID_HANDLE_VALUE) {
			m_memo_mp3 = new(byte, m_memo_mp3_size);
		}
	}
	return (m_memo_mp3 != null);
}



CLameEnc::Write(word *pwWaveSamples, int size),INT
{
	if (!m_memo_mp3) size = 0;
	int total_writen = 0, encoded;

	while (size > 0)
	{
		int to_write = size;
		if (to_write > m_Samples)  to_write = m_Samples;
		int err = beEncodeChunk(m_hbeStream, to_write>>1, pwWaveSamples, m_memo_mp3, &encoded);
		if (err) return 0;
		pwWaveSamples += to_write;
		size -= to_write;
		WriteFile    (m_hFile, m_memo_mp3, encoded, &encoded, NULL);
		total_writen += encoded;
	}
	return total_writen;
}



CLameEnc::Close()
{
	UINT bytes_cnt;

	beDeinitStream(m_hbeStream, m_memo_mp3, &bytes_cnt);
	WriteFile     (m_hFile,     m_memo_mp3, bytes_cnt, &bytes_cnt, NULL);
	beCloseStream (m_hbeStream);
	if (!m_attached) CloseHandle(m_hFile);
	m_attached = false;
	m_hFile = INVALID_HANDLE_VALUE;
	m_hbeStream = 0;
	delete m_memo_mp3; m_memo_mp3 = null;
	return;
}

// --------------------------------------------------------------------------------------------------------------------

//virtual (custom) structure - extracted from mp3sync dword

struct MP3_FILE_HEADER /*POINTER means a boolean, integer or pointer to string*/
{
	INT version;
	INT layer;
	INT error_protection;
	INT m_bitrate;
	INT sampling_freq;
	INT padding;
	INT extension;
	POINTER m_mode;
	INT mode_ext;
	POINTER copyright;
	POINTER original;
	POINTER emphasis;
}





#ifdef _mp3tag

/*
sub mp3fileGetTag(path:STRING),INT
	BFILE F
	INT result, a, b, br, syncpos
	UINT test_dword
	UINT buff[129]:' buff[128]=saved dword from buff[127]
	POINTER pbuff

	ClearStack()
	if openfile(F, path, "r") then goto mp3fileGetTag_quit
	pbuff = buff

	ReadFile(F, pbuff, 128<<2, &br, 0)
	buff[128] = buff[127]
	' call htonl() for each dword in buff
	htonl_Buff(pbuff, 128)

	while br>0

		for a = 1 to 127 // for each dword in buffer -1
			for b = 1 to 32 // for each bit in dword 

				test_dword = buff[0]

				if (test_dword & 0xFFF00000) = 0xFFF00000
					' found sync
					print "found sync at ",syncpos
					result = TRUE
					showHeader(test_dword)
					goto mp3fileGetTag_close

				else
					memRotateLeftDwords(pbuff, 128)
				endif

			next b
			syncpos++
		next a

		' restore saved dword
		buff[0] = buff[128]
		' and read next pack
		ReadFile(F, &buff+4, 127<<2, &br, 0)
		buff[128] = buff[127]
		' call htonl()/[asm=bswap] for each dword in buffer
		htonl_Buff(pbuff, 128)
	wend

	label mp3fileGetTag_close
	closefile F

	label mp3fileGetTag_quit
	return result
}



sub showHeader(header:UINT)
	MP3_FILE_HEADER mp3fh
	'encode header and change some variables to string pointers
	mp3fileDecodeHeader(header, mp3fh, TRUE) //use strings

	print ".version          mpeg", mp3fh.version,"\x08.0"
	print ".layer            ", mp3fh.layer
	print ".error_protection ", mp3fh.error_protection
	print ".m_bitrate          ", mp3fh.m_bitrate
	print ".sampling_freq    ", mp3fh.sampling_freq
	print ".padding          ", mp3fh.padding
	print ".extension        ", mp3fh.extension
	print ".m_mode             ", StringOrInt(mp3fh.m_mode)
	print ".mode_ext         ", mp3fh.mode_ext
	print ".copyright        ", StringOrInt(mp3fh.copyright)
	print ".original         ", StringOrInt(mp3fh.original)
	print ".emphasis         ", StringOrInt(mp3fh.emphasis)
	return
}


sub StringOrInt(p:POINTER),STRING
{
	if p>0x400000 then return *<STRING>p
	return ltrim$(str$(p))
}
*/
#endif
#endif
